﻿--[[ 

	Poisoner
	¯¯¯¯¯¯¯¯¯¯
	> Options

]]


PoisonerOptions = {};
PoisonerOptions.needUpdate = false;

Poisoner_Poison16 = {};
Poisoner_Poison16_SHIFT = {};
Poisoner_Poison16_CTRL = {};
Poisoner_Poison16_ALT = {};
Poisoner_Poison17 = {};
Poisoner_Poison17_SHIFT = {};
Poisoner_Poison17_CTRL = {};
Poisoner_Poison17_ALT = {};
Poisoner_Poison18 = {};
Poisoner_Poison18_SHIFT = {};
Poisoner_Poison18_CTRL = {};
Poisoner_Poison18_ALT = {};

function Poisoner_round(num, idp)
  local mult = 10^(idp or 0)
  return math.floor(num * mult + 0.5) / mult
end

-- load current profile onto settings
function PoisonerOptions_LoadSettings()
	
	PoisonerOptions_GetPoisonNames()
	
	local IP = POISONER_CONFIG.Buy.IP
	local CP = POISONER_CONFIG.Buy.CP
	local WP = POISONER_CONFIG.Buy.WP
	local DP = POISONER_CONFIG.Buy.DP
	local MP = POISONER_CONFIG.Buy.MP

	PoisonerOptions_Slider_IP:SetValue(IP)
	PoisonerOptions_Slider_CP:SetValue(CP)
	PoisonerOptions_Slider_WP:SetValue(WP)
	PoisonerOptions_Slider_DP:SetValue(DP)
	PoisonerOptions_Slider_MP:SetValue(MP)
	
	PoisonerOptions_TextIP:SetText(IP)
	PoisonerOptions_TextCP:SetText(CP)
	PoisonerOptions_TextWP:SetText(WP)
	PoisonerOptions_TextDP:SetText(DP)
	PoisonerOptions_TextMP:SetText(MP)
	
	if (POISONER_CONFIG.Enabled == 1) then
		PoisonerOptions_ChkBox_Enable:SetChecked(1)
	else
		PoisonerOptions_ChkBox_Enable:SetChecked(0)
	end
	
	if (POISONER_CONFIG.MinimapButton.Active == 1) then
		PoisonerOptions_ChkBox_MBShow:SetChecked(1)
	else
		PoisonerOptions_ChkBox_MBShow:SetChecked(0)
	end
	if (POISONER_CONFIG.MinimapButton.Lock == 1) then
		PoisonerOptions_ChkBox_MBLock:SetChecked(1)
	else
		PoisonerOptions_ChkBox_MBLock:SetChecked(0)
	end	
	if ( POISONER_CONFIG.MinimapButton.Parent == "PoisonerStateHeader" ) then
		PoisonerOptions_ChkBox_MBParentOwn:SetChecked(1)
		PoisonerOptions_ChkBox_MBParentMinimap:SetChecked(0)
	elseif ( POISONER_CONFIG.MinimapButton.Parent == "Minimap" ) then
		PoisonerOptions_ChkBox_MBParentOwn:SetChecked(0)
		PoisonerOptions_ChkBox_MBParentMinimap:SetChecked(1)
	end	
	if ( POISONER_CONFIG.MinimapButton.MenuPosition == "left" ) then
		PoisonerOptions_ChkBox_MPLeft:SetChecked(1)
		PoisonerOptions_ChkBox_MPRight:SetChecked(0)
	elseif ( POISONER_CONFIG.MinimapButton.MenuPosition == "right" ) then
		PoisonerOptions_ChkBox_MPLeft:SetChecked(0)
		PoisonerOptions_ChkBox_MPRight:SetChecked(1)
		
	end
	
	if ( POISONER_CONFIG.TooltipType == "full" ) then
		PoisonerOptions_ChkBox_ToolTipFull:SetChecked(1)
		PoisonerOptions_ChkBox_ToolTipName:SetChecked(0)
	elseif ( POISONER_CONFIG.TooltipType == "name" ) then
		PoisonerOptions_ChkBox_ToolTipFull:SetChecked(0)	
		PoisonerOptions_ChkBox_ToolTipName:SetChecked(1)
	end
	
	PoisonerDropDown_UpdateDropDownText(Poisoner_DropDownMenu_Mainhand, POISONER_CONFIG.Preset.Normal.Mainhand)
	PoisonerDropDown_UpdateDropDownText(Poisoner_DropDownMenu_Offhand, POISONER_CONFIG.Preset.Normal.Offhand)
	PoisonerDropDown_UpdateDropDownText(Poisoner_DropDownMenu_Throwweapon, POISONER_CONFIG.Preset.Normal.Throwweapon)
	
	PoisonerDropDown_UpdateDropDownText(Poisoner_DropDownMenu_Mainhand_SHIFT, POISONER_CONFIG.Preset.SHIFT.Mainhand)
	PoisonerDropDown_UpdateDropDownText(Poisoner_DropDownMenu_Offhand_SHIFT, POISONER_CONFIG.Preset.SHIFT.Offhand)
	PoisonerDropDown_UpdateDropDownText(Poisoner_DropDownMenu_Throwweapon_SHIFT, POISONER_CONFIG.Preset.SHIFT.Throwweapon)
	
	PoisonerDropDown_UpdateDropDownText(Poisoner_DropDownMenu_Mainhand_CTRL, POISONER_CONFIG.Preset.CTRL.Mainhand)
	PoisonerDropDown_UpdateDropDownText(Poisoner_DropDownMenu_Offhand_CTRL, POISONER_CONFIG.Preset.CTRL.Offhand)
	PoisonerDropDown_UpdateDropDownText(Poisoner_DropDownMenu_Throwweapon_CTRL, POISONER_CONFIG.Preset.CTRL.Throwweapon)
	
	PoisonerDropDown_UpdateDropDownText(Poisoner_DropDownMenu_Mainhand_ALT, POISONER_CONFIG.Preset.ALT.Mainhand)
	PoisonerDropDown_UpdateDropDownText(Poisoner_DropDownMenu_Offhand_ALT, POISONER_CONFIG.Preset.ALT.Offhand)
	PoisonerDropDown_UpdateDropDownText(Poisoner_DropDownMenu_Throwweapon_ALT, POISONER_CONFIG.Preset.ALT.Throwweapon)
	
	PoisonerOptions_ChkBox_ShowTimer:SetChecked(POISONER_CONFIG.Timer.Active);
	PoisonerOptions_ChkBox_TimerOutput_Aura:SetChecked(POISONER_CONFIG.Timer.Aura);
	PoisonerOptions_ChkBox_TimerOutput_Aura_Lock:SetChecked(POISONER_CONFIG.Timer.Lock);
	PoisonerOptions_ChkBox_TimerOutput_Chat:SetChecked(POISONER_CONFIG.Timer.Chat);
	PoisonerOptions_ChkBox_TimerOutput_ErrorFrame:SetChecked(POISONER_CONFIG.Timer.ErrorFrame);
	
	PoisonerOptions_ChkBox_AutoBuy:SetChecked(POISONER_CONFIG.Buy.Active);
	PoisonerOptions_ChkBox_AutoBuy_Prompt:SetChecked(POISONER_CONFIG.Buy.Prompt);
	
	PoisonerOptions_PoisonTimerSlider:SetValue(Poisoner_WarningThreshold)	
	
	PoisonerOptions_PoisonTimerScaleSlider:SetValue(POISONER_CONFIG.Timer.Scale)
	PoisonerOptions_PoisonTimerAlphaSlider:SetValue(POISONER_CONFIG.Timer.Alpha)
	
	PoisonerOptions_ChkBox_ReapplyButton_Lock:SetChecked(POISONER_CONFIG.ReapplyButton.Lock);
	
end

-- save current profile settings
function PoisonerOptions_SaveSettings()
	POISONER_CONFIG.Buy.IP = PoisonerOptions_Slider_IP:GetValue()
	POISONER_CONFIG.Buy.CP = PoisonerOptions_Slider_CP:GetValue()
	POISONER_CONFIG.Buy.WP = PoisonerOptions_Slider_WP:GetValue()
	POISONER_CONFIG.Buy.DP = PoisonerOptions_Slider_DP:GetValue()
	POISONER_CONFIG.Buy.MP = PoisonerOptions_Slider_MP:GetValue()

	local IP = POISONER_CONFIG.Buy.IP
	local CP = POISONER_CONFIG.Buy.CP
	local WP = POISONER_CONFIG.Buy.WP
	local DP = POISONER_CONFIG.Buy.DP
	local MP = POISONER_CONFIG.Buy.MP
	
	PoisonerOptions_TextIP:SetText(IP)
	PoisonerOptions_TextCP:SetText(CP)
	PoisonerOptions_TextWP:SetText(WP)
	PoisonerOptions_TextDP:SetText(DP)
	PoisonerOptions_TextMP:SetText(MP)
	
	Poisoner_WarningThreshold = PoisonerOptions_PoisonTimerSlider:GetValue()
	POISONER_CONFIG.Timer.WarningThreshold = Poisoner_WarningThreshold
	
	if ( PoisonerOptions_ChkBox_Enable:GetChecked() ) then
		POISONER_CONFIG.Enabled = 1;
		Poisoner_Enable()
	else
		POISONER_CONFIG.Enabled = 0;
		Poisoner_Disable()
	end
	
	if ( PoisonerOptions_ChkBox_MBShow:GetChecked() ) then
		POISONER_CONFIG.MinimapButton.Active = 1
	else
		POISONER_CONFIG.MinimapButton.Active = 0
		PoisonerMinimapButton:Hide()
	end
	if ( PoisonerOptions_ChkBox_MBLock:GetChecked() ) then
		POISONER_CONFIG.MinimapButton.Lock = 1
	else
		POISONER_CONFIG.MinimapButton.Lock = 0
	end	
	if ( PoisonerOptions_ChkBox_MBParentOwn:GetChecked() ) then
		POISONER_CONFIG.MinimapButton.Parent = "PoisonerStateHeader";
	elseif ( PoisonerOptions_ChkBox_MBParentMinimap:GetChecked() ) then
		POISONER_CONFIG.MinimapButton.Parent = "Minimap";
	end	
	if ( PoisonerOptions_ChkBox_MPLeft:GetChecked() ) then
		POISONER_CONFIG.MinimapButton.MenuPosition = "left";
		Poisoner_SetPosition("left")
	elseif ( PoisonerOptions_ChkBox_MPRight:GetChecked() ) then
		POISONER_CONFIG.MinimapButton.MenuPosition = "right";
		Poisoner_SetPosition("right")
	end
	
	if ( PoisonerOptions_ChkBox_ToolTipFull:GetChecked() ) then
		POISONER_CONFIG.TooltipType = "full";
	elseif ( PoisonerOptions_ChkBox_ToolTipName:GetChecked() ) then
		POISONER_CONFIG.TooltipType = "name";
	end
	
	if ( PoisonerOptions_ChkBox_ShowTimer:GetChecked() ) then
		POISONER_CONFIG.Timer.Active = 1;
	else
		POISONER_CONFIG.Timer.Active = 0;
	end
	if ( PoisonerOptions_ChkBox_TimerOutput_Aura:GetChecked() ) then
		POISONER_CONFIG.Timer.Aura = 1;
	else
		POISONER_CONFIG.Timer.Aura = 0;
		PoisonerTimer_Mainhand:Hide()
		PoisonerTimer_Offhand:Hide()
		PoisonerTimer_Throwweapon:Hide()
	end
	if ( PoisonerOptions_ChkBox_TimerOutput_Aura_Lock:GetChecked() ) then
		POISONER_CONFIG.Timer.Lock = 1;
		PoisonerTimer_UpdateLock();
	else
		POISONER_CONFIG.Timer.Lock = 0;
		PoisonerTimer_UpdateLock();
	end
	if ( PoisonerOptions_ChkBox_TimerOutput_Chat:GetChecked() ) then
		POISONER_CONFIG.Timer.Chat = 1;
	else
		POISONER_CONFIG.Timer.Chat = 0;
	end
	if ( PoisonerOptions_ChkBox_TimerOutput_ErrorFrame:GetChecked() ) then
		POISONER_CONFIG.Timer.ErrorFrame = 1;
	else
		POISONER_CONFIG.Timer.ErrorFrame = 0;
	end
	
	if ( PoisonerOptions_ChkBox_AutoBuy:GetChecked() ) then
		POISONER_CONFIG.Buy.Active = 1;
	else
		POISONER_CONFIG.Buy.Active = 0;
	end
	if ( PoisonerOptions_ChkBox_AutoBuy_Prompt:GetChecked() ) then
		POISONER_CONFIG.Buy.Prompt = 1;
	else
		POISONER_CONFIG.Buy.Prompt = 0;
	end
	
	if ( PoisonerOptions_ChkBox_ReapplyButton_Lock:GetChecked() ) then
		POISONER_CONFIG.ReapplyButton.Lock = 1;
		Poisoner_ReapplyButton_UpdateLock();
	else
		POISONER_CONFIG.ReapplyButton.Lock = 0;
		Poisoner_ReapplyButton_UpdateLock();
	end
	
end

function PoisonerOptions_ToggleSettings(self)
	if not InCombatLockdown() then -- not in combat
		if ( PoisonerOptions_SettingsFrame:IsVisible() ) then
			--PoisonerOptions_SaveSettings();
			PoisonerOptions_SettingsFrame:Hide();
		else
			PoisonerOptionsTab_OnClick(self, 1);
			PoisonerOptions_LoadSettings();
			PoisonerOptions_SettingsFrame:ClearAllPoints();
			PoisonerOptions_SettingsFrame:SetPoint("CENTER");
			PoisonerOptions_SettingsFrame:Show();
		end
	else 
		PoisonerOptions_SettingsFrame:Hide();
	end
end

function PoisonerOptions_CallUpdate()
	PoisonerOptions.needUpdate = true;
	Poisoner_NoPoison_Warning1 = false;
	Poisoner_NoPoison_Warning2 = false;
	Poisoner_NoPoison_Warning3 = false;
end

function PoisonerOptions_GetPoisonNames()
	--patched out with 4.0.1	--PoisonerOptions_APtitle = GetItemInfo(21835);	--Beruhigendes Gift
	PoisonerOptions_CP_Title:SetText(GetItemInfo(3775));	--Verkrüppelndes Gift
	PoisonerOptions_MP_Title:SetText(GetItemInfo(5237));	--Gedankenbenebelndes Gift
	PoisonerOptions_DP_Title:SetText(GetItemInfo(2892));	--Tödliches Gift
	PoisonerOptions_IP_Title:SetText(GetItemInfo(6947));	--Sofort wirkendes Gift
	PoisonerOptions_WP_Title:SetText(GetItemInfo(10918));	--Wundgift
end

local PoisonerOptions_BeingDragged
-- Start dragging the frame
function PoisonerOptions_OnDragStart(self)
	self:StartMoving();
	PoisonerOptions_BeingDragged = true;
end

-- Stop dragging the frame
function PoisonerOptions_OnDragStop(self)
	if (PoisonerOptions_BeingDragged) then
		self:StopMovingOrSizing()
		PoisonerOptions_BeingDragged = false;
	end
end

function PoisonerOptionsScaleSlider_OnValueChanged(value)
	PoisonerOptions_CONFIG.Scale = value;
	PoisonerOptions_MainFrame:SetScale(PoisonerOptions_CONFIGScale);
end

function PoisonerOptionsAlphaSlider_OnValueChanged(value)
	PoisonerOptions_CONFIG.Alpha = value;
	PoisonerOptions_MainFrame:SetAlpha(PoisonerOptions_CONFIGAlpha);
end

function PoisonerOptionsTab_OnClick(self, index)
	if ( not index ) then
		index = self:GetID();
	end

	if ( PoisonerOptions_SettingsFrame.numTabs == nil) then
		PanelTemplates_SetNumTabs(PoisonerOptions_SettingsFrame, 4);
	end

	PanelTemplates_SetTab(PoisonerOptions_SettingsFrame, index);
	PoisonerOptions_HideAllSettingFrames();
	if ( index == 1 ) then
		PoisonerOptions_SettingsFrame1:Show();
	elseif ( index == 2 ) then
		PoisonerOptions_SettingsFrame2:Show();
	elseif ( index == 3 ) then
		PoisonerOptions_SettingsFrame3:Show();
	elseif ( index == 4 ) then
		PoisonerOptions_SettingsFrame4:Show();
	--elseif ( index == 5 ) then
		--PoisonerOptions_SettingsFrame5:Show();
	end
end

function PoisonerOptions_HideAllSettingFrames()
		PoisonerOptions_SettingsFrame1:Hide();
		PoisonerOptions_SettingsFrame2:Hide();
		PoisonerOptions_SettingsFrame3:Hide();
		PoisonerOptions_SettingsFrame4:Hide();
		--PoisonerOptions_SettingsFrame5:Hide();
end

-- Move Handler

function PoisonerOptions_MoveSettingsHandler_OnMouseDown(arg1)
	if (arg1 == "LeftButton") then
		PoisonerOptions_SettingsFrame:StartMoving();
	end
end

function PoisonerOptions_MoveSettingsHandler_OnMouseUp(arg1)
	if (arg1 == "LeftButton") then
		PoisonerOptions_SettingsFrame:StopMovingOrSizing();
	end
end


function PoisonerOptions_greyout()

	if (POISONER_CONFIG.Buy.Active == 1) then
		PoisonerOptions_ChkBox_AutoBuy_PromptText:SetTextColor(0.94, 0.77, 0, 1)
	elseif (POISONER_CONFIG.Buy.Active == 0) then
		PoisonerOptions_ChkBox_AutoBuy_PromptText:SetTextColor(0.37647058823529411764705882352941, 0.37647058823529411764705882352941, 0.37647058823529411764705882352941, 1)
	end

end


































function PoisonerOptions_OnLoad(self)
		  Poisoner_IsAPVendor = false;
		  Poisoner_IsIPVendor = false;
		  Poisoner_IsCPVendor = false;
		  Poisoner_IsWPVendor = false;
		  Poisoner_IsDPVendor = false;  
		  Poisoner_IsMPVendor = false;
		  Poisoner_IsReagentVendor = false;
	--DEFAULT_CHAT_FRAME:AddMessage("PoisonerOptions_OnLoad");
	self:RegisterEvent("PLAYER_ENTERING_WORLD");
	self:RegisterEvent("MERCHANT_SHOW");
	self:RegisterEvent("MERCHANT_CLOSED");
	self:RegisterEvent('VARIABLES_LOADED');
	

	StaticPopupDialogs["POISONER_RESTOCK_POISON"] = {
		text = PoisonerOptions_RestockQuestion,
		button1 = YES,
		button2 = NO,
		OnAccept = function() PoisonerOptions_RestockReagents()  end,
		timeout = 0,
		whileDead = 0,
		hideOnEscape = 1
	}
	
end

function PoisonerOptions_OnEvent(self, event)
	if event == "VARIABLES_LOADED" then
		if (POISONER_CONFIG == nil) then
			POISONER_CONFIG = {};
			local _, cls = UnitClass("player");
			if (cls == "ROGUE") then
				POISONER_CONFIG.Enabled = 1;
			end
		end
		
		
		if (not POISONER_CONFIG.TooltipType) then
			POISONER_CONFIG.TooltipType = "full";
		end
		
		if (not POISONER_CONFIG.MinimapButton) then
			if POISONER_CONFIG.Enabled == 1 then
				POISONER_CONFIG.MinimapButton = { 
				Active = 1,
				Lock = 0,
				Parent = "PoisonerStateHeader",
				}
			end
		end
		if (not POISONER_CONFIG.MinimapButton.Parent) then
			POISONER_CONFIG.MinimapButton.Parent = "PoisonerStateHeader";
		end
		
		if (POISONER_CONFIG.Preset == nil) then
			POISONER_CONFIG.Preset = {};
		end
		if (POISONER_CONFIG.Preset.Normal == nil) then
			POISONER_CONFIG.Preset.Normal = {};
		end
		if (POISONER_CONFIG.Preset.SHIFT == nil) then
			POISONER_CONFIG.Preset.SHIFT = {};
		end
		if (POISONER_CONFIG.Preset.CTRL == nil) then
			POISONER_CONFIG.Preset.CTRL = {};
		end
		if (POISONER_CONFIG.Preset.ALT == nil) then
			POISONER_CONFIG.Preset.ALT = {};
		end
		if ( not POISONER_CONFIG.Preset.Normal.Mainhand ) then
			POISONER_CONFIG.Preset.Normal.Mainhand = 1;
		end
		if ( not POISONER_CONFIG.Preset.Normal.Offhand ) then
			POISONER_CONFIG.Preset.Normal.Offhand = 1;
		end
		if ( not POISONER_CONFIG.Preset.Normal.Throwweapon ) then
			POISONER_CONFIG.Preset.Normal.Throwweapon = 1;
		end
		if ( not POISONER_CONFIG.Preset.SHIFT.Mainhand ) then
			POISONER_CONFIG.Preset.SHIFT.Mainhand = 1;
		end
		if ( not POISONER_CONFIG.Preset.SHIFT.Offhand ) then
			POISONER_CONFIG.Preset.SHIFT.Offhand = 1;
		end
		if ( not POISONER_CONFIG.Preset.SHIFT.Throwweapon ) then
			POISONER_CONFIG.Preset.SHIFT.Throwweapon = 1;
		end
		if ( not POISONER_CONFIG.Preset.CTRL.Mainhand ) then
			POISONER_CONFIG.Preset.CTRL.Mainhand = 1;
		end
		if ( not POISONER_CONFIG.Preset.CTRL.Offhand ) then
			POISONER_CONFIG.Preset.CTRL.Offhand = 1;
		end
		if ( not POISONER_CONFIG.Preset.CTRL.Throwweapon ) then
			POISONER_CONFIG.Preset.CTRL.Throwweapon = 1;
		end
		if ( not POISONER_CONFIG.Preset.ALT.Mainhand ) then
			POISONER_CONFIG.Preset.ALT.Mainhand = 1;
		end
		if ( not POISONER_CONFIG.Preset.ALT.Offhand ) then
			POISONER_CONFIG.Preset.ALT.Offhand = 1;
		end
		if ( not POISONER_CONFIG.Preset.ALT.Throwweapon ) then
			POISONER_CONFIG.Preset.ALT.Throwweapon = 1;
		end
		
		
		if (POISONER_CONFIG.Timer == nil) then
			POISONER_CONFIG.Timer = {};
		end		
		if (not POISONER_CONFIG.Timer.Position) then
		POISONER_CONFIG.Timer.Position = { 
			XPos = 0,
			YPos = 100,
			Anchor = "CENTER",
			RelativeTo = "CENTER",
			Parent = nil,
			}
		end
		if ( not POISONER_CONFIG.Timer.Scale ) then
			POISONER_CONFIG.Timer.Scale = 1;
		end
		if ( not POISONER_CONFIG.Timer.Alpha ) then
			POISONER_CONFIG.Timer.Alpha = 1;
		end
		if ( not POISONER_CONFIG.Timer.Active ) then
			POISONER_CONFIG.Timer.Active = 1;
		end
		if ( not POISONER_CONFIG.Timer.Lock ) then
			POISONER_CONFIG.Timer.Lock = 1;
		end
		if ( not POISONER_CONFIG.Timer.Chat ) then
			POISONER_CONFIG.Timer.Chat = 1;
		end
		if ( not POISONER_CONFIG.Timer.ErrorFrame ) then
			POISONER_CONFIG.Timer.ErrorFrame = 1;
		end
		if ( not POISONER_CONFIG.Timer.Aura ) then
			POISONER_CONFIG.Timer.Aura = 1;
		end
		
		
		if (POISONER_CONFIG.ReapplyButton == nil) then
			POISONER_CONFIG.ReapplyButton = {};
		end		
		if ( not POISONER_CONFIG.ReapplyButton.Lock ) then
			POISONER_CONFIG.ReapplyButton.Lock = 1;
		end
		if (not POISONER_CONFIG.ReapplyButton.Position) then
		POISONER_CONFIG.ReapplyButton.Position = { 
			XPos = 0,
			YPos = 0,
			Anchor = "CENTER",
			RelativeTo = "CENTER",
			Parent = nil,
			}
		end
		if ( not POISONER_CONFIG.ReapplyButton.Scale ) then
			POISONER_CONFIG.ReapplyButton.Scale = 1;
		end
		if ( not POISONER_CONFIG.ReapplyButton.Alpha ) then
			POISONER_CONFIG.ReapplyButton.Alpha = 1;
		end
		
		
		if (not POISONER_CONFIG.Poisons) then
		POISONER_CONFIG.Poisons = { 
			CPName = 0,	--Verkrüppelndes Gift
			MPName = 0,	--Gedankenbenebelndes Gift
			DPName = 0,	--Tödliches Gift
			IPName = 0,	--Sofort wirkendes Gift
			WPName = 0,	--Wundgift
			}
		end
	
		if (POISONER_CONFIG.Buy == nil) then
			POISONER_CONFIG.Buy = {};
		end
		if ( not POISONER_CONFIG.Buy.Active) then
			POISONER_CONFIG.Buy.Active = 1;
		end
		if ( not POISONER_CONFIG.Buy.Prompt) then
			POISONER_CONFIG.Buy.Prompt = 0;
		end
		if (not POISONER_CONFIG.Buy.IP) then POISONER_CONFIG.Buy.IP = 0 end
		if (not POISONER_CONFIG.Buy.CP) then POISONER_CONFIG.Buy.CP = 0 end
		if (not POISONER_CONFIG.Buy.WP) then POISONER_CONFIG.Buy.WP = 0 end
		if (not POISONER_CONFIG.Buy.DP) then POISONER_CONFIG.Buy.DP = 0 end
		if (not POISONER_CONFIG.Buy.MP) then POISONER_CONFIG.Buy.MP = 0 end
		if (not POISONER_CONFIG.Timer.WarningThreshold) then POISONER_CONFIG.Timer.WarningThreshold = 2 end	
		
		if (POISONER_CONFIG.MinimapButton.Active == 1) then
			PoisonerMinimapButton:Show()
		elseif (POISONER_CONFIG.MinimapButton.Active == 0) then			
			PoisonerMinimapButton:Hide()
		end
		
		if (POISONER_CONFIG.MinimapButton.Parent == "Minimap") then
			PoisonerMinimapButton:SetParent(Minimap)
		elseif (POISONER_CONFIG.MinimapButton.Parent == "PoisonerStateHeader") then
			PoisonerMinimapButton:SetParent(PoisonerStateHeader)
		end
		
		
		Poisoner_WarningThreshold = POISONER_CONFIG.Timer.WarningThreshold			
		PoisonerOptions_PoisonTimerSlider:SetValue(Poisoner_WarningThreshold)
		
		PoisonerTimer_IconFrame:ClearAllPoints()
		PoisonerTimer_IconFrame:SetPoint(POISONER_CONFIG.Timer.Position.Anchor, UIParent, POISONER_CONFIG.Timer.Position.RelativeTo, POISONER_CONFIG.Timer.Position.XPos, POISONER_CONFIG.Timer.Position.YPos)
		PoisonerTimer_IconFrame:SetScale(POISONER_CONFIG.Timer.Scale)
		PoisonerTimer_IconFrame:SetAlpha(POISONER_CONFIG.Timer.Alpha)
		PoisonerTimer_IconFrame:Show()
		
		Poisoner_ReapplyButton_Overlay:ClearAllPoints()
		Poisoner_ReapplyButton_Overlay:SetPoint(POISONER_CONFIG.ReapplyButton.Position.Anchor, UIParent, POISONER_CONFIG.ReapplyButton.Position.RelativeTo, POISONER_CONFIG.ReapplyButton.Position.XPos, POISONER_CONFIG.ReapplyButton.Position.YPos)
		Poisoner_ReapplyButton_Overlay:SetScale(POISONER_CONFIG.ReapplyButton.Scale)
		Poisoner_ReapplyButton_Overlay:SetAlpha(POISONER_CONFIG.ReapplyButton.Alpha)
		Poisoner_ReapplyButton_Overlay:Show()
		
		Poisoner_DropDownMenu_CreateFrames()
		
		Poisoner_ReapplyButton_CreateOverlay();
		Poisoner_ReapplyButton_UpdateLock()
		
		PoisonerDropDown_SelectPresetPoison("Mainhand", POISONER_CONFIG.Preset.Normal.Mainhand, "Normal")
		PoisonerDropDown_SelectPresetPoison("Mainhand", POISONER_CONFIG.Preset.SHIFT.Mainhand, "SHIFT")
		PoisonerDropDown_SelectPresetPoison("Mainhand", POISONER_CONFIG.Preset.CTRL.Mainhand, "CTRL")
		PoisonerDropDown_SelectPresetPoison("Mainhand", POISONER_CONFIG.Preset.ALT.Mainhand, "ALT")
		
		PoisonerDropDown_SelectPresetPoison("Offhand", POISONER_CONFIG.Preset.Normal.Offhand, "Normal")
		PoisonerDropDown_SelectPresetPoison("Offhand", POISONER_CONFIG.Preset.SHIFT.Offhand, "SHIFT")
		PoisonerDropDown_SelectPresetPoison("Offhand", POISONER_CONFIG.Preset.CTRL.Offhand, "CTRL")
		PoisonerDropDown_SelectPresetPoison("Offhand", POISONER_CONFIG.Preset.ALT.Offhand, "ALT")
		
		PoisonerDropDown_SelectPresetPoison("Throwweapon", POISONER_CONFIG.Preset.Normal.Throwweapon, "Normal")
		PoisonerDropDown_SelectPresetPoison("Throwweapon", POISONER_CONFIG.Preset.SHIFT.Throwweapon, "SHIFT")
		PoisonerDropDown_SelectPresetPoison("Throwweapon", POISONER_CONFIG.Preset.CTRL.Throwweapon, "CTRL")
		PoisonerDropDown_SelectPresetPoison("Throwweapon", POISONER_CONFIG.Preset.ALT.Throwweapon, "ALT")
		
		PoisonerOptions_SettingsFrameTitleString:SetText("Poisoner |cff8080ff"..GetAddOnMetadata("Poisoner", "Version").."|r")
		
		self:UnregisterEvent("VARIABLES_LOADED");
		
	elseif (event == "MERCHANT_SHOW") then
			--DEFAULT_CHAT_FRAME:AddMessage("MerchantShow")
			Poisoner_ReagentsMissing = false 
			Poisoner_IsAPVendor = false 
			Poisoner_IsIPVendor = false
			Poisoner_IsCPVendor = false 
			Poisoner_IsWPVendor = false 
			Poisoner_IsDPVendor = false
			Poisoner_IsMPVendor = false  
			Poisoner_IsReagentVendor = false
			
			local IP = POISONER_CONFIG.Buy.IP
			local CP = POISONER_CONFIG.Buy.CP
			local WP = POISONER_CONFIG.Buy.WP
			local DP = POISONER_CONFIG.Buy.DP
			local MP = POISONER_CONFIG.Buy.MP

			if GetItemCount(6947) < IP
			or GetItemCount(3775) < CP
			or GetItemCount(10918) < WP
			or GetItemCount(2892) < DP
			or GetItemCount(5237) < MP

			then Poisoner_ReagentsMissing = true
			end

			for i = 1, GetMerchantNumItems(), 1 do
				local name, texture, price, quantity, numAvailable, isUsable, extendedCost = GetMerchantItemInfo(i)
				if name == GetItemInfo(6947) then
					Poisoner_IsIPVendor = true 
				elseif name == GetItemInfo(3775) then
					Poisoner_IsCPVendor = true 
				elseif name == GetItemInfo(10918) then
					Poisoner_IsWPVendor = true 
				elseif name == GetItemInfo(2892) then
					Poisoner_IsDPVendor = true 
				elseif name == GetItemInfo(5237) then
					Poisoner_IsMPVendor = true 
				end

			end

			if (Poisoner_IsAPVendor or Poisoner_IsIPVendor or Poisoner_IsCPVendor or Poisoner_IsWPVendor or Poisoner_IsDPVendor or Poisoner_IsMPVendor) then 
				Poisoner_IsReagentVendor = true
			end
			
			if (Poisoner_IsReagentVendor and Poisoner_ReagentsMissing and (POISONER_CONFIG.Buy.Prompt == 0) and (POISONER_CONFIG.Buy.Active == 1)) then
				StaticPopup_Show("POISONER_RESTOCK_POISON")
			elseif (Poisoner_IsReagentVendor and Poisoner_ReagentsMissing and (POISONER_CONFIG.Buy.Active == 1)) then
				PoisonerOptions_RestockReagents()
			end
		
	elseif (event == "MERCHANT_CLOSED") then	
		StaticPopup_Hide("POISONER_RESTOCK_POISON")
		
	end
end


	

function PoisonerOptions_RestockReagents()

	--DEFAULT_CHAT_FRAME:AddMessage("RestockReagents")
	
	local IP = POISONER_CONFIG.Buy.IP
	local CP = POISONER_CONFIG.Buy.CP
	local WP = POISONER_CONFIG.Buy.WP
	local DP = POISONER_CONFIG.Buy.DP
	local MP = POISONER_CONFIG.Buy.MP
	
	local IPIndex, CPIndex, WPIndex, DPIndex, MPIndex
	for i = 1, GetMerchantNumItems(), 1 do
		local name, texture, price, quantity, numAvailable, isUsable, extendedCost = GetMerchantItemInfo(i)
		if name == GetItemInfo(6947) then
			IPIndex = i
		end
		if name == GetItemInfo(3775) then
			CPIndex = i
		end
		if name == GetItemInfo(10918) then
			WPIndex = i
		end
		if name == GetItemInfo(2892) then
			DPIndex = i
		end
		if name == GetItemInfo(5237) then
			MPIndex = i
		end
		
	end

 
		local tempIP = GetItemCount(6947)
		if tempIP < IP and Poisoner_IsIPVendor then
			local calcIP = IP - tempIP
			while calcIP > 20 do
				BuyMerchantItem(IPIndex, 20)
				calcIP = calcIP - 20
			end
			BuyMerchantItem(IPIndex, calcIP)
		end
		local tempCP = GetItemCount(3775)
		if tempCP < CP and Poisoner_IsCPVendor then
			local calcCP = CP - tempCP
			while calcCP > 20 do
				BuyMerchantItem(CPIndex, 20)
				calcCP = calcCP - 20
			end
			BuyMerchantItem(CPIndex, calcCP)
		end	

		local tempWP = GetItemCount(10918)
		 if tempWP < WP and Poisoner_IsWPVendor then
			local calcWP = WP - tempWP
			while calcWP > 20 do
				BuyMerchantItem(WPIndex, 20)
				calcWP = calcWP - 20
			end
			BuyMerchantItem(WPIndex, calcWP)
		end
  
		local tempDP = GetItemCount(2892)
		if tempDP < DP and Poisoner_IsDPVendor then
			local calcDP = DP - tempDP
			while calcDP > 20 do
				BuyMerchantItem(DPIndex, 20)
				calcDP = calcDP - 20
			end
			BuyMerchantItem(DPIndex, calcDP)
		end
  
		local tempMP = GetItemCount(5237)
		if tempMP < MP and Poisoner_IsMPVendor then
			local calcMP = MP - tempMP
			while calcMP > 20 do
				BuyMerchantItem(MPIndex, 20)
				calcMP = calcMP - 20
			end
			BuyMerchantItem(MPIndex, calcMP)
		end
	
end